/// <reference types="node" />
import type { CoordinateType } from '@visactor/vgrammar-coordinate';
import type { BaseEventHandler, IRunningConfig, IView, ViewSpec, CoordinateOption, IPlot, IPlotMarkConstructor, IPlotOptions, PlotSpec } from '@visactor/vgrammar-core';
export declare class Plot implements IPlot {
    static useMarks(marks: IPlotMarkConstructor[]): void;
    readonly view: IView;
    private _semanticMarks;
    private _hasInited?;
    private _coordinate;
    private _logger;
    private _theme?;
    constructor(option?: IPlotOptions);
    theme(theme: string): this;
    private _mergeScales;
    protected parseViewSpec(): ViewSpec;
    run(morphConfig?: IRunningConfig): this;
    release(): this;
    updateSpec(spec: PlotSpec): this;
    parseSpec(spec: PlotSpec, isUpdate?: boolean): this;
    getImageBuffer(): Buffer;
    on(type: string, handler: BaseEventHandler): this;
    off(type: string, handler?: BaseEventHandler): this;
    protected getCoordinateId(viewId?: string | number): string;
    coordinate(type: CoordinateType, spec?: Omit<CoordinateOption, 'type'>): this;
    interval(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    line(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    area(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    cell(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    ruleX(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    ruleY(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    image(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    path(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    polygon(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    rectX(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    rectY(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    rect(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    rule(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    symbol(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    text(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    sankey(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    sunburst(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    tree(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    treemap(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    circlePacking(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    wordcloud(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    wordcloudShape(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
    imagecloud(): import("@visactor/vgrammar-core").ISemanticMark<any, any>;
}
