import type { RectEncodeChannels, PlotRectEncoderSpec, SemanticTooltipOption, WithDefaultEncode, GenerateBaseEncodeSpec, CrosshairSpec, Nil, ScaleSpec, ValueOf } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class RectSemanticMark extends SemanticMark<PlotRectEncoderSpec, RectEncodeChannels> {
    static readonly type = PlotMakType.rect;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    parseScaleByEncode(channel: RectEncodeChannels, option: ValueOf<WithDefaultEncode<PlotRectEncoderSpec, RectEncodeChannels>, RectEncodeChannels>): ScaleSpec | Nil;
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotRectEncoderSpec, RectEncodeChannels>): GenerateBaseEncodeSpec<PlotRectEncoderSpec>;
}
